<?php
// POS command: Do not modify
// Includes
include_once 'PHPLibraries/GlobalFunctions.php';
include_once 'PHPLibraries/DBDecoders.php';

function DBGetSettings()
{
	$TempSettingsData = LoadFile('Data/Settings.php');
	
	$TempSettingsArray = DecodeMessage($TempSettingsData);
	
	for ($t = 0; $t <= count($TempSettingsArray)-1; $t++)
	{
		switch ($TempSettingsArray[$t])
		{
		case 'RequireTrackingForOrdersOver':
			$_SESSION['Settings']['RequireTrackingForOrdersOver'] = $TempSettingsArray[($t+1)];
			$t++;
			break;

		case 'DefaultSortProperty':
			$_SESSION['Settings']['DefaultSortProperty'] = $TempSettingsArray[($t+1)];
			$t++;
			break;

		case 'BaseAddress':
			$_SESSION['Settings']['BaseAddress'] = $TempSettingsArray[($t+1)];
			$t++;
			break;

		case 'OrdersEmail':
			$_SESSION['Settings']['OrdersEmail'] = $TempSettingsArray[($t+1)];
			$t++;
			break;
			
		case 'EnableWebStats':
			if ($TempSettingsArray[($t+1)] == '1')
			{
				$_SESSION['Settings']['EnableWebStats'] = true;
			}
			else
			{
				$_SESSION['Settings']['EnableWebStats'] = false;
			}
			$t++;
			break;

		case 'UseMetric':
			if ($TempSettingsArray[($t+1)] == '1')
			{
				$_SESSION['Settings']['UseMetric'] = true;
			}
			else
			{
				$_SESSION['Settings']['UseMetric'] = false;
			}
			$t++;
			break;

		default:
			echo "<br>Unknown Setting: ".$TempSettingsArray[$t]."<br>";
			$t++;
			break;
		}
	}
	
}

function LoadPropertiesToExcludeFromSort()
{
	$TempReturn = array();

	if (file_exists('Data/ExcludePropertiesFromSort.txt'))
	{
		$TempReturn = LoadUTF8FileIntoArray('Data/ExcludePropertiesFromSort.txt', true);
	}

	return $TempReturn;
}

function GetThumbnailFileName($TempFileName)
{
	$TempExtension = substr($TempFileName,strrpos($TempFileName, ".")+1);
	$TempFileNameWithoutExtension = substr($TempFileName,0, strrpos($TempFileName, "."));
	$TempFileNameWithoutExtension = str_replace('\\', '/', $TempFileNameWithoutExtension);
	
	return $TempFileNameWithoutExtension."-thumb.".$TempExtension;
}

function GetPropertyValue($TempPropertyValues, $TempPropertyName)
{
	$TempReturn = '';

	for ($t = 0; $t <= count($TempPropertyValues) - 1; $t++)
		{
		if ($TempPropertyValues[$t]['Name'][0] == $TempPropertyName)
			{
			$TempReturn = $TempPropertyValues[$t]['Value'];
			}
		}
		
	return $TempReturn;
}

function DBSortProductData($TempProducts, $TempSort)
{
	$TempReturn = array();
	
	$TempTongue = '0';
	
	if (array_key_exists('Tongue', $_SESSION))
	{
	  $TempTongue = $_SESSION['Tongue'];
	}
		
	if (strlen($TempSort) > 0)
		{
		$TempArrayToSort = array();
		
		if ($TempSort == 'Name')
			{
			
			for ($t = 0; $t<= count($TempProducts) - 1; $t++)
				{
				$TempArrayToSort[RemoveAccentedCharacters($TempProducts[$t]['Name']).":".$TempProducts[$t]['ID']] = $t;
				}			
			}
		else
			{

			$TempPropertiesIndex = LoadUTF8FileIntoArray('Data/ProductPropertiesIndex.php');
			$TempPropertiesValuesIndex = LoadUTF8FileIntoArray('Data/ProductPropertiesValuesIndex.php');
			
			$TempSortName = $TempPropertiesIndex[$TempSort];

			for ($t = 0; $t<= count($TempProducts) - 1; $t++)
				{
				$TempPropertyValues = $TempProducts[$t]['PropertyValues'];
				//var_dump($TempPropertyValues);
				//AddBr(1);
				
				$TempFound = -1;
				
				for ($g = 0; $g <= count($TempPropertyValues) - 1; $g++)
					{
					if ($TempSortName == $TempPropertyValues[$g]['Name'][0])
						{
						$TempFound = $g;
						}
					}
				
				if ($TempFound > -1)
					{
					//echo "In Array".$TempFound."<br>";
					$TempArrayToSort[RemoveAccentedCharacters(Translate($TempPropertyValues[$TempFound]['Value'], $TempTongue)).":".$TempProducts[$t]['Name'].":".$TempProducts[$t]['ID']] = $t;
					}
				else
					{
					//echo "Not Array: ".$TempSortName."<br>";
					$TempArrayToSort['zzzzzzzzzz'.":".$TempProducts[$t]['Name'].":".$TempProducts[$t]['ID']] = $t;
					}
				
				}
				
			}
			//var_dump($TempArrayToSort);
			uksort($TempArrayToSort, "strnatcasecmp");
			
			foreach ($TempArrayToSort as $key => $value)
				{
				$TempReturn[] = $TempProducts[$value];
				}
		}
	else
		{
		echo "No sort:";
		var_dump($TempSort);
		AddBr(2);
		}

	return $TempReturn;
}

function DBGetProductProperties()
{
	$TempReturn = array();
	
	$Properties = LoadUTF8FileIntoArray('Data/ProductProperties.php');
	
	$t = 0;
	
	while ($t <= count($Properties) - 1)
	{
		
		$TempProductArray = array();
		$TempID = $Properties[$t]; //Product ID

		$TempPropertiesCount = $Properties[($t+1)];
		
		$t = $t + 2;
		
		$TempPropertiesArray = array();
		
		for ($g = 0; $g <= $TempPropertiesCount * 2 - 1; $g = $g + 2)
		{
			$TempPropertiesArray[$Properties[($t+$g)]] = $Properties[($t+1+$g)];
		}
		
		$t = $t + $TempPropertiesCount * 2;
		
		$TempProductArray = array();		
		
		$TempReturn[$TempID] = $TempPropertiesArray;
	}
	
	return $TempReturn;
}

function DBGetProductByProperties($TempProductsProperties, $TempPropertyIndex)
{
	$TempReturn = array();
	
	foreach ($TempProductsProperties as $key => $value)
	{
		
		if (array_key_exists($TempPropertyIndex, $value))
		{
			$TempReturn[] = $key;
		}
	}
	
	return $TempReturn;
}

function DBGetProductsIDsByPropertyValueStatement($TempStatement)
{
	$TempReturn = array();
	$TempResult = array();
	
	$TempProductsProperties = DBGetProductProperties();

	$TempPropertiesIndex = LoadUTF8FileIntoArray('Data/ProductPropertiesIndex.php');
	$TempPropertiesValuesIndex = LoadUTF8FileIntoArray('Data/ProductPropertiesValuesIndex.php');

	$TempStatementData = explode(',', $TempStatement);
	
	$TempPreviousResult = array();
	$TempCommand = '';
	
	$TempIndex = 0;
	
	while ($TempIndex <= count($TempStatementData) - 1)
		{
		$TempPropertyIndex = $TempStatementData[$TempIndex];
		$TempPropertyValue = $TempStatementData[$TempIndex + 1];
		$TempIndex = $TempIndex + 2;
	
		$TempResult = DBFilterProductPropertiesByValue($TempProductsProperties, $TempPropertyIndex, $TempPropertyValue);

		if (!$TempCommand == '')
			{
			//echo "Processing Command: ".$TempCommand;
			//AddBr(2);
			
			$TempNewResult = array();
			
			if ($TempCommand == "AND")
				{
				for ($t = 0; $t <= count($TempPreviousResult) - 1; $t++)
					{
					if (in_array($TempPreviousResult[$t], $TempResult))
						{
						$TempNewResult[] = $TempPreviousResult[$t];
						}
					}
				$TempResult = $TempNewResult;
				}

			if ($TempCommand == "OR")
				{
				$TempNewResult = $TempResult;
				for ($t = 0; $t <= count($TempPreviousResult) - 1; $t++)
					{
					if (!in_array($TempPreviousResult[$t], $TempResult))
						{
						$TempNewResult[] = $TempPreviousResult[$t];
						}
					}
				$TempResult = $TempNewResult;
				}

			$TempCommand = '';
			$TempPreviousResult = '';
			}

		if ($TempIndex <= (count($TempStatementData) - 1))
			{
			$TempPreviousResult = $TempResult;
			$TempCommand = $TempStatementData[$TempIndex];
			$TempIndex = $TempIndex + 1;
			}
		
		}
	
	
	$TempReturn = $TempResult;
	
	return $TempReturn;
}

function DBFilterProductPropertiesByValue($TempProductsProperties, $TempPropertyIndex, $TempPropertyValue)
{
	$TempReturn = array();
	$TempResult = array();
	
	$TempDoEventsCounter = 0;
	
	foreach ($TempProductsProperties as $key => $value)
	{
		
		$TempProductID = $key;
		$TempProductProperties = $value;
		
		if (array_key_exists($TempPropertyIndex, $TempProductProperties))
		{
			if ($TempProductProperties[$TempPropertyIndex] == $TempPropertyValue)
			{
				$TempResult[$key] = $TempProductProperties;
			}
		}
		
	}

	foreach ($TempResult as $key => $value)
	{
		$TempReturn[] = $key;
	}
	
	return $TempReturn;
}

function UpdateSoldProductData(&$TempProduct)
{
	$TempSoldItems = array();
	
	
	$TempSoldItems = LoadFileIntoArray('TempFiles/SoldItems.txt');
	
	$t = 0;
	
	$TempCurrentID = '';
	
	while ($t < count($TempSoldItems))
	{
		switch ($TempSoldItems[$t])
		{
			case '[ID]':
			
				$TempCurrentID = $TempSoldItems[$t+1];
				$t=$t+1;
				break;
				
			case '[Quantities]':
			
				if ($TempProduct['ID'] == $TempCurrentID)
				{
			
					$TempQuantities = array();
					$TempQuantities = explode(',', $TempSoldItems[$t+1]);
				
					$TempProduct['InStock'] = $TempProduct['InStock'] - $TempQuantities[0];

					for ($g = 1; $g < count($TempQuantities); $g++)
					{
						$TempProduct['Bundles'][$g-1]['InStock'] = $TempProduct['Bundles'][$g-1]['InStock'] - $TempQuantities[$g];
					}
				}
				
				$t=$t+1;
				break;
		
			case '[EndProduct]':
				break;

			case '[EndOrder]':
				break;
				
			case '[OrderNo]':
				$t=$t+1;
				break;

			default:
				$t=$t+1;
				break;

			
		}
		
		$t = $t+1;
	}

}

function DBGetProductData($TempProductID, $TempTongue)
{

	$TempReturn = "";
	
	$MainIndex = LoadFileIntoArray('Data/ProductMainIndex.php');
	
	$TempPtr = 0;
	
	$TempCount = count($MainIndex);
	$TempFound = false;
	
	while (($TempPtr < $TempCount) && !$TempFound)
	{
		$ProductID = $MainIndex[$TempPtr];
		$TempStartPos = $MainIndex[$TempPtr+1];
		$TempLength = $MainIndex[$TempPtr+2];
		
		if ($ProductID == $TempProductID)
		{
			$TempFound = true;

			$TempData = LoadFileData('Data/ProductData.php',$TempStartPos,$TempLength-1);
			
			$TempList = array();
			
			$TempList = DecodeMessage($TempData);

			$TempReturn = GetProductDataInner($TempList);
			
			//Traductions
			$TempReturn['Name'] = DecodeMessage($TempReturn['Name']);
			$TempReturn['Name'] = GetStringListItemWithZeroFallBack($TempReturn['Name'], $TempTongue);
			
			$TempReturn['Description'] = DecodeMessage($TempReturn['Description']);
			$TempReturn['Description'] = GetStringListItemWithZeroFallBack($TempReturn['Description'], $TempTongue);
			
			// Dates
			$TempReturn['DateCreated'] = strtotime($TempReturn['DateCreated']);
			
			if (array_key_exists('UseReleaseDate', $TempReturn))
			{
				$TempReturn['UseReleaseDate'] = true;
				$TempReturn['ReleaseDate'] = strtotime($TempReturn['ReleaseDate']);
			}
			else
			{
				$TempReturn['UseReleaseDate'] = false;
				$TempReturn['ReleaseDate'] = '';
			}
			
			if (!array_key_exists('SpecialOrderDelayWeeks', $TempReturn))
			{
				$TempReturn['SpecialOrderDelayWeeks'] = '';
			}
			
			if (!array_key_exists('SoldOnlyInStore', $TempReturn))
			{
				$TempReturn['SoldOnlyInStore'] = '';
			}

			// Pictures
			$TempReturn['Pictures.FileName'] = DecodeMessage($TempReturn['Pictures.FileName']);
			$TempReturn['Pictures.Description'] = DecodeMessage($TempReturn['Pictures.Description']);
			
			$TempReturn['Price'] = DBDecodeProductPrice($TempReturn['Price']);
			$TempReturn['Bundles'] = DBDecodeProductBundles($TempReturn['Bundles'], $TempTongue);
			
			$TempReturn['PropertyValues'] = DBDecodeProductPropertyValues($TempReturn['PropertyValues']);
			
			for ($t = 0; $t <= count($TempReturn['Bundles']) - 1; $t++)
			{
				$TempReturn['Bundles'][$t]['Order.Qty'] = 1;
			}
			
			$TempReturn['Dimensions'] = DBDecodeDimensionsData($TempReturn['Dimensions']);
			
		}
		
		$TempPtr = $TempPtr + 3;
	}

	UpdateSoldProductData($TempReturn);
	
	return $TempReturn;
}

function DBGetProductDataFromIDsShort($TempProductIDs, $TempTongue)
{
	$TempReturnArray = array();
	$TempReturn = "";
	
	$MainIndex = LoadFileIntoArray('Data/ProductMainIndex.php');
	
	$TempPtr = 0;
	
	$TempCount = count($MainIndex);
	
	// Open the file
	$fh = fopen('Data/ProductData.php', 'r')		or die($php_errormsg);
	$tries = 3;
	while ($tries > 0)
	{
		$locked = flock($fh,LOCK_EX | LOCK_NB);
		if (! $locked)
		{
			sleep(2);
			$tries--;
		}
		else
		{
			$tries = 0;
		}
	}
	
	if ($locked)
	{
		
		while (($TempPtr < $TempCount))
		{
			$ProductID = $MainIndex[$TempPtr];
			$TempStartPos = $MainIndex[$TempPtr+1];
			$TempLength = $MainIndex[$TempPtr+2];
			
			if (in_array($ProductID, $TempProductIDs))
			{

				fseek($fh, $TempStartPos);
				$TempData = fread($fh, $TempLength+1);
		
				$TempList = array();
				
				$TempList = DecodeMessage($TempData);

				$TempReturn = GetProductDataInner($TempList);
				
				//Traductions
				$TempReturn['Name'] = DecodeMessage($TempReturn['Name']);
				$TempReturn['Name'] = GetStringListItemWithZeroFallBack($TempReturn['Name'], $TempTongue);
				
				//$TempReturn['Description'] = DecodeMessage($TempReturn['Description']);
				//$TempReturn['Description'] = GetStringListItemWithZeroFallBack($TempReturn['Description'], $TempTongue);
				
				// Dates
				$TempReturn['DateCreated'] = strtotime($TempReturn['DateCreated']);
				
				if (array_key_exists('UseReleaseDate', $TempReturn))
				{
					$TempReturn['UseReleaseDate'] = true;
					$TempReturn['ReleaseDate'] = strtotime($TempReturn['ReleaseDate']);
				}
				else
				{
					$TempReturn['UseReleaseDate'] = false;
					$TempReturn['ReleaseDate'] = '';
				}
				
				if (!array_key_exists('SpecialOrderDelayWeeks', $TempReturn))
				{
					$TempReturn['SpecialOrderDelayWeeks'] = '';
				}
				
				// Pictures
				$TempReturn['Pictures.FileName'] = DecodeMessage($TempReturn['Pictures.FileName']);
				//$TempReturn['Pictures.Description'] = DecodeMessage($TempReturn['Pictures.Description']);
				
				$TempReturn['Price'] = DBDecodeProductPrice($TempReturn['Price']);
				$TempReturn['Bundles'] = DBDecodeProductBundles($TempReturn['Bundles'], $TempTongue);
				
				$TempReturn['PropertyValues'] = DBDecodeProductPropertyValues($TempReturn['PropertyValues']);
				
				//for ($t = 0; $t <= count($TempReturn['Bundles']) - 1; $t++)
				//{
				//	$TempReturn['Bundles'][$t]['Order.Qty'] = 1;
				//}
				
				//$TempReturn['Dimensions'] = DBDecodeDimensionsData($TempReturn['Dimensions']);
				
				UpdateSoldProductData($TempReturn);
				
				$TempReturnArray[] = $TempReturn;
			}
			
			$TempPtr = $TempPtr + 3;
		}
		
		flock($fh,LOCK_UN)			or die($php_errormsg);
		fclose($fh)					or die($php_errormsg);

	}
	
	return $TempReturnArray;
}

function GetProductDataInner($TempData)
{
	$TempReturn = array();
	
	$TempPtr = 0;
	$TempCount = count($TempData);
	
	while ($TempPtr < $TempCount)
	{
		$TempReturn[$TempData[$TempPtr]] = $TempData[$TempPtr+1];
		
		$TempPtr = $TempPtr+2;
	}
	
	return $TempReturn;
}

function DBIsProductIDValid($TempProductIDToCheck)
{

	$TempValidIDs = LoadFileIntoArray('Data/ProductsValidIDs.php');

	$Key = array_search($TempProductIDToCheck, $TempValidIDs, true);
	
	$TempReturn = false;
	
	if ($Key > 0)
	{
		$TempReturn = true;
	}
	
	return $TempReturn;
	
}

function DBGetProductStatus($TempProduct)
{
	if ($TempProduct['InStock'] > 0)
	{
		$TempReturn = 'In stock';
	}
	else
	{
		$TempReturn = 'Other';
	}
	
	return $TempReturn;
}

function DBGetFinalPrice($TempPrice)
{
	$TempReturn = 0;
	
	$TempDiscountType = 0;
	
	$TempDiscountType = $TempPrice['Discount']['DiscountType'];
	
	switch ($TempDiscountType)
	{
		
	case 0:
		//$TempReturn = $TempPrice['Price'];
		
		$TempReturn = GetMemberPrice($TempPrice);
				
		break;
		
	case 1:
		// Fixed amount
		$TempReturn = $TempPrice['Price']-$TempPrice['Discount']['Value'];
		break;

	case 2:
		// Percentage
		$TempReturn = $TempPrice['Price'] - ($TempPrice['Price']*$TempPrice['Discount']['Value']/100);
		break;
	}
	
	$TempMemberPrice = GetMemberPrice($TempPrice);
	
	if ($TempMemberPrice < $TempReturn)
	{
	  $TempReturn = $TempMemberPrice;
	}
	
	return $TempReturn;
}

function DBGetShippingData($TempTongue)
{
	$TempData = LoadFileData('Data/ShippingData.php',0,filesize('Data/ShippingData.php')-1);
	
	$TempReturn = DBDecodeShippingData($TempData, $TempTongue);
	
	return $TempReturn;	
}

function GetBundlesQtyArray($TempProduct)
{
	$TempReturn = array();
	
	// Add single item
	$TempReturn[] = 1;
	
	for ($t = 0; $t <= count($TempProduct['Bundles'])-1; $t++)
	{
		$TempReturn[] = 0;
	}
	
	return $TempReturn;
}

function DBGetProductPropertyValuesArray($TempProduct)
{
	$TempReturn = array();
	
	for ($h = 0; $h <= count($TempProduct['PropertyValues']) - 1; $h++)
	{
		
		$TempReturn[] = $TempProduct['PropertyValues'][$h]['Name'][0].":==->".$TempProduct['PropertyValues'][$h]['Value'];
	}
	
	return $TempReturn;
}

function DBGetAddToCartProductTemplate($TempProduct)
{
	$TempReturn = '';
	
	$TempTongue = $_SESSION['Tongue'];
	$TempAddToCartLink = 'cart.php?Action=Add&ID='.$TempProduct['ID'];
	
	
	if ($TempProduct['Discontinued'] == 'True')
		{
		$TempReturn = LoadFile('Templates/TTemplateProductStatusDiscontinued'.$TempTongue.'.txt');
		}
	else
		{
		if ($TempProduct['ReleaseDate'] <> '')
			{
			$TempReturn = LoadFile('Templates/TTemplateProductStatusReleaseDate'.$TempTongue.'.txt');
			$TempReturn = str_replace('[Object.ReleaseDate]', date("Y/m/d", $TempProduct['ReleaseDate']), $TempReturn);
			}
		else
			{
			if ($TempProduct['SpecialOrderDelayWeeks'] <>'')
				{
				$TempReturn = LoadFile('Templates/TTemplateProductStatusSpecialOrder'.$TempTongue.'.txt');
				$TempReturn = str_replace('[Object.SpecialOrderDelayWeeks]', $TempProduct['SpecialOrderDelayWeeks'], $TempReturn);
				}
			else
				{
				if ($TempProduct['InStockCheck'] == 'True')
					{
					if (IsProductInStock($TempProduct))
						{
						if ($TempProduct['SoldOnlyInStore'] == 'True')
							{
							$TempReturn = LoadFile('Templates/TTemplateProductStatusSoldOnlyInStore'.$TempTongue.'.txt');
							}
						else
							{
							$TempReturn = LoadFile('Templates/TTemplateProductStatusInStock'.$TempTongue.'.txt');
							}
						}
					else
						{
						$TempReturn = LoadFile('Templates/TTemplateProductStatusOutOfStock'.$TempTongue.'.txt');
						}
					}
				else
					{
					$TempReturn = LoadFile('Templates/TTemplateProductStatusOutOfStock'.$TempTongue.'.txt');
					}
				}
			}
		}
		
	$TempReturn = str_replace('[Link]', $TempAddToCartLink, $TempReturn);
		
	return $TempReturn;
}

function IsProductInStock($TempProduct)
{
	$TempReturn = false;
	
	if ($TempProduct['InStock'] > 0)
	{
		$TempReturn = true;
	}

	for ($t = 0; $t < count($TempProduct['Bundles']); $t++)
	{
		if ($TempProduct['Bundles'][$t]['InStock'] > 0)
		{
			$TempReturn = true;
		}
	}
	
	return $TempReturn;

}

function GetMemberPrice($TempPrice)
{
    // Set default value
	$TempReturn = $TempPrice['Price'];
	
	if (array_key_exists('MemberPrice', $TempPrice))
	{
		if ($_SESSION['LoggedIn'])
		{
			$TempReturn = $TempPrice['MemberPrice'];
		}
	}
	
	return $TempReturn;
}

?>
